---
apiVersion: batch/v1
kind: Job
metadata:
  name: {{metadata.name}}
  labels:
    tier: apps
spec:
  ttlSecondsAfterFinished: 3600
  template:
    spec:
      initContainers:
        # Stage in the file list / cache file
      - name: stage-data
        image: containers.ligo.org/rucio/igwn-rucio-client/gfal2-utils
        volumeMounts:
        - name: data
          mountPath: /data
        - name: proxy-volume
          mountPath: /tmp
        env:
          - name: X509_USER_PROXY
            value: "/tmp/x509up"
          - name: SRC
            value: {{gwrucio.url}}/{{gwrucio.diskcache}}
          - name: DEST
            value: /data/{{gwrucio.diskcache}}
      containers:
      - name: rucio-clients
        image: containers.ligo.org/rucio/igwn-rucio-client/rucio-clients
        command: ["/bin/bash", "-ce", "/docker-entrypoint.sh gwrucio_registrar ${CONFIG} -c ${DISKCACHE} -r ${RSE} -t ${THREADS}"]
#command: [ "/bin/bash", "-ce", "tail -f /dev/null" ]
        resources:
          limits:
            cpu: 1
            memory: 500Mi
            ephemeral-storage: 10Gi
          requests:
            cpu: 50m
            memory: 200Mi
            ephemeral-storage: 100Mi
        env:
          - name: X509_USER_PROXY
            value: "/tmp/x509up"
          - name: CONFIG
            value: "/opt/rucio/registrar/{{env("GWRUCIO_INI")}}"
          - name: DISKCACHE
            value: "/data/{{gwrucio.diskcache}}"
          - name: RSE
            value: "{{gwrucio.rse}}"
          - name: THREADS
            value: "{{gwrucio.threads}}"
        imagePullPolicy: Always
        volumeMounts:
        - name: rucio-cfg
          mountPath: /opt/rucio/etc
        - name: registrar-ini
          mountPath: /opt/rucio/registrar
        - name: sshkey
          readOnly: true
          mountPath: /root/.ssh
        - name: proxy-volume
          mountPath: /tmp
        - name: data
          mountPath: /data
      volumes:
      - name: rucio-cfg
        configMap:
          name: {{rucio.configmap}}
          items:
           - key: {{rucio.configfile}}
             path: rucio.cfg
      - name: registrar-ini
        configMap:
          name: {{metadata.name}}-ini
          items:
           - key: {{env("GWRUCIO_INI")}}
             path: {{env("GWRUCIO_INI")}}
      - name: sshkey
        secret:
          secretName: client-ssh-key
      - name: proxy-volume
        secret:
          secretName: proxy-cert
          items:
          - key: x509up
            path: x509up
            mode: 0400
          optional: true
      - name: data
        emptyDir: {}
      restartPolicy: OnFailure
